<img src="http://t-neumann.github.io/slamdunk/images/slamdunk_logo_light.png" width="300" title="Slamdunk">

### Streamlining SLAM-Seq analysis with ultra-high sensitivity.

[![GitHub release](https://img.shields.io/github/release/t-neumann/slamdunk.svg)](https://github.com/t-neumann/slamdunk/releases/latest)
[![Travis CI](https://img.shields.io/travis/t-neumann/slamdunk.svg)](https://travis-ci.org/t-neumann/slamdunk)

[![Docker Pulls](https://img.shields.io/docker/pulls/tobneu/slamdunk.svg)](https://hub.docker.com/r/tobneu/slamdunk)
[![Docker Automated build](https://img.shields.io/docker/automated/tobneu/slamdunk.svg)](https://hub.docker.com/r/tobneu/slamdunk/builds/)

[![install with bioconda](https://img.shields.io/badge/install%20with-bioconda-brightgreen.svg?style=flat-square)](http://bioconda.github.io/recipes/slamdunk/README.html)
[![Anaconda build](https://anaconda.org/bioconda/slamdunk/badges/version.svg
)](https://anaconda.org/bioconda/slamdunk)
[![Anaconda downloads](https://anaconda.org/bioconda/slamdunk/badges/downloads.svg
)](https://anaconda.org/bioconda/slamdunk)

[![PyPI release](https://img.shields.io/pypi/v/slamdunk.svg)](https://pypi.python.org/pypi/slamdunk)
![Github Stars](https://img.shields.io/github/stars/t-neumann/slamdunk.svg?style=social&label=Star)

-----

### Slamdunk documentation

http://t-neumann.github.io/slamdunk

### Please cite

Neumann, T., Herzog, V. A., Muhar, M., Haeseler, von, A., Zuber, J., Ameres, S. L., & Rescheneder, P. (2019). [Quantification of experimentally induced nucleotide conversions in high-throughput sequencing datasets](https://bmcbioinformatics.biomedcentral.com/articles/10.1186/s12859-019-2849-7). BMC Bioinformatics, 20(1), 258. http://doi.org/10.1186/s12859-019-2849-7

# Helper function to check whether Rslamdunk libraries are available
# Install if libraries are not available

# Copyright (c) 2015 Tobias Neumann, Philipp Rescheneder.
#
# This file is part of Slamdunk.
# 
# Slamdunk is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
# 
# Slamdunk is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

checkLib <- function(libLoc) {
	
	list.of.packages <- c("getopt","ggplot2","gridExtra","RColorBrewer","lattice","matrixStats","assertthat","lazyeval","tibble")
	new.packages <- list.of.packages[!(list.of.packages %in% installed.packages(lib.loc = libLoc)[,"Package"])]
	
	if(length(new.packages)) install.packages(new.packages, repos="http://cran.wu.ac.at/", lib = libLoc, dependencies = TRUE)
}

#!/usr/bin/env Rscript

# Copyright (c) 2015 Tobias Neumann, Philipp Rescheneder.
#
# This file is part of Slamdunk.
#
# Slamdunk is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# Slamdunk is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

library(getopt)
library(bbmle)

spec = matrix(c(
  'help'      , 'h', 0, "logical","print the usage of the command",
  'file', "f", 2,"character","",
  'rate', "r", 2,"character", "",
  'output', "o", 2,"character","Output tsv"
),ncol = 5,byrow=T)

opt = getopt(spec)

if ( !is.null(opt$help) || length(opt)==3 ) {
  #get the script name
  cmd = commandArgs(FALSE)
  self = strsplit(cmd[grep("--file",cmd)],"=")[[1]][2]
  cat(basename(self),": Create mismatch plots from rate tabs.\n\n")
  #print a friendly message and exit with a non-zero error code
  cat(getopt(spec,command = self,usage=T))
  q(status=1);
}

if ( is.null(opt$file) ) stop("arg file must be specified")
if ( is.null(opt$output) ) stop("arg output must be specified")
if ( is.null(opt$rate) ) stop("arg rate must be specified")

# a: percentage of converted transcripts
# b: conversion rate
LL <- function(a, b) {
  R = a * (( 1 - b ) ^ ( sample$n - sample$k )) * (b ^ sample$k) * choose(sample$n, sample$k) + ( 1 - a ) * as.numeric(sample$k == 0)
  -sum(log(R))
}

# Estimate a with fixed b
LL2 <- function(as) {
  b = estb
  rs = c()
  for(a in as)  {
    R = a * (( 1 - b ) ^ ( sample$n - sample$k )) * (b ^ sample$k) * choose(sample$n, sample$k) + ( 1 - a ) * as.numeric(sample$k == 0)
    rs = c(rs, -sum(log(R)))
  }
  rs
}

readMeatInfo <- function(fileName) {
  #fileName = filesSlamDunk[1]
  sampleInfo = read.table(fileName, nrows = 1, comment.char = "")
  version = paste(lapply(sampleInfo[1,1:3], as.character), collapse = '\t')
  sampleID = as.character(sampleInfo[1, ]$V7)
  sampleName = as.character(sampleInfo[1, ]$V6)
  sampleType = as.character(sampleInfo[1, ]$V8)
  sampleTime = as.numeric(sampleInfo[1, ]$V9)
  sampleInfo = read.table(fileName, nrows = 1, skip = 1, comment.char = "")
  annotationMD5 = as.character(sampleInfo[1, ]$V3)
  annotationName = as.character(sampleInfo[1, ]$V2)
  c(sampleID, sampleName, sampleType, sampleTime, annotationName, annotationMD5, version)
}



file = opt$file
#file = "/project/ngs/philipp/slamdunk-analysis/simulation/simulation/halflife_cov60_rl38/slamdunk/count/sample_3_pulse_30min_rep1_reads_slamdunk_mapped_filtered_tcount_perread.tsv"
#files = as.character(ordered(strsplit(file, ",")[[1]]))

output = opt$output
#output = "/project/ngs/philipp/slamdunk-analysis/veronika/ngm-20161027/count-examples/34504_An312_wt-2n_mRNA-slamseq-autoquant_1h-R2.fq_slamdunk_mapped_filtered_tcount_mle.tsv"

estb = as.numeric(opt$rate)
#estb = 0.024

meta = readMeatInfo(file)
id = meta[1]
type = meta[3]
time = meta[4]

data = read.table(file, header = T, stringsAsFactors = F)
#head(data)

for(i in 1:nrow(data)) {
  #i = 1
  N = as.numeric(strsplit(data[i,]$ReadCount, ",")[[1]])
  k = as.numeric(strsplit(data[i,]$TcReadCount, ",")[[1]])
  sample = data.frame(n = N, k = k)
  fit = mle2(minuslogl = LL2, start = list(as = 0.29), method = "L-BFGS-B", lower = c(as = 0.000001), upper = c(as = 0.99))
  confinv = confint(fit)

  #result = rbind(result, c(id, type, time, name, fit@coef[[1]], confinv[[1]], confinv[[2]]))
  data[i,]$ConversionRate = fit@coef[[1]]
  data[i,]$ReadCount = length(N)
  data[i,]$TcReadCount = sum(k > 0)
  data[i,]$ConversionRateLower = confinv[[1]]
  data[i,]$ConversionRateUpper = confinv[[2]]
}

if(sum(is.na(data$ConversionRateLower) > 0)) {
  data[is.na(data$ConversionRateLower), ]$ConversionRateLower = 0
}
if(sum(is.na(data$ConversionRateUpper) > 0)) {
  data[is.na(data$ConversionRateUpper), ]$ConversionRateUpper = 1
}

#all = data.frame()
#for(file in files) {
#  part = read.table(file, header = T)
#  all = rbind(all, part)
#}
#head(all)
# Estimate b from all data
#sample = all
#fit = mle2(minuslogl = LL, start = list(a = 0.1, b = 0.01), method = "L-BFGS-B", lower = c(a = 0.000001, b = 0.000001), upper = c(a = 0.99, b = 0.1))

#result = c()
#names = as.character(unique(all$utr))

#for(name in names) {
#  #name = names[2]
#  sample = all[all$utr == name, ]
#
#  fit = mle2(minuslogl = LL2, start = list(as = 0.29), method = "L-BFGS-B", lower = c(as = 0.000001), upper = c(as = 0.99))
#  confinv = confint(fit)
##  result = rbind(result, c(id, type, time, name, fit@coef[[1]], confinv[[1]], confinv[[2]]))
#
#}
#

# Read header
header = readLines(file, 2)
con <- file(output, open="wt")
# Print header
writeLines(header[1], con)
writeLines(header[2], con)
# Print data
write.table(data, con, sep = "\t", quote = F, row.names = F, col.names = T)
close(con)

#!/usr/bin/env Rscript

# Copyright (c) 2015 Tobias Neumann, Philipp Rescheneder.
#
# This file is part of Slamdunk.
#
# Slamdunk is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# Slamdunk is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

library(getopt)

spec = matrix(c(
  'help'      , 'h', 0, "logical","print the usage of the command",
  'simulated', "s", 2,"character","Half-lifes inferred from SlamDunk results",
  'predicted', "p", 2,"character","Simulated Half-Lifes",
  'truth', "t", 2,"character","True Half-Lifes",
  'output', "o", 2,"character","Output pdf",
  'missing', "m", 2,"character","List of utrs with missing half-life"
),ncol = 5,byrow=T)

opt = getopt(spec)

if ( !is.null(opt$help) || length(opt)==5 ) {
  #get the script name
  cmd = commandArgs(FALSE)
  self = strsplit(cmd[grep("--file",cmd)],"=")[[1]][2]
  cat(basename(self),": Create mismatch plots from rate tabs.\n\n")
  #print a friendly message and exit with a non-zero error code
  cat(getopt(spec,command = self,usage=T))
  q(status=1);
}


if ( is.null(opt$simulated) ) stop("arg simulated must be specified")
if ( is.null(opt$predicted) ) stop("arg slamdunk must be specified")
if ( is.null(opt$truth) ) stop("arg truth must be specified")
if ( is.null(opt$output) ) stop("arg output must be specified")
if ( is.null(opt$missing) ) stop("arg missing must be specified")

truthFile = opt$truth
#truthFile = "/project/ngs/philipp/slamdunk-analysis/simulation/simulation_2/finalAnnotation_test_cut_chrM_correct_100_original_utrs.bed"
#truthFile = "/project/ngs/philipp/slamdunk-analysis/simulation/simulation_3/finalAnnotation_test_cut_chrM_correct_original_utrs.bed"
simHLFile = opt$simulated
#simHLFile = "/project/ngs/philipp/slamdunk-analysis/simulation/simulation_2/pooja_UTR_annotation_examples_sample_1_0min_utrsummary_halflifes.tsv"
#simHLFile = "/project/ngs/philipp/slamdunk-analysis/simulation/simulation_3/finalAnnotation_test_1_0min_utrsummary_halflifes.tsv"
predHLFile = opt$predicted
#predHLFile = "/project/ngs/philipp/slamdunk-analysis/simulation/simulation_2/slamdunk/halflifes/pooja_UTR_annotation_examples_sample_1_0min_reads_slamdunk_mapped_filtered_tcount_halflifes.tsv"
#predHLFile = "/project/ngs/philipp/slamdunk-analysis/simulation/simulation_3/slamdunk/halflifes/finalAnnotation_test_1_0min_reads_slamdunk_mapped_filtered_tcount_halflifes.tsv"
output = opt$output
missing = opt$missing

trueHL = read.csv(truthFile, sep="\t", header = F)
colnames(trueHL) = c("chr", "start", "stop", "name", "halflife", "strand")
simHL = read.csv(simHLFile, sep="\t", header = T)
predHL = read.csv(predHLFile, sep="\t")

predHL$simulated_hl = simHL$score
predHL$true_hl = trueHL$halflife
predHL$multiperc = predHL$multiMapCount / predHL$readsCPM
head(simHL)

tmp = predHL[is.na(predHL$score) | is.na(predHL$simulated_hl), ]
predHL = predHL[!is.na(predHL$score) & !is.na(predHL$simulated_hl), ]

predHL$log2DiffSim = log2((predHL$score + 0.1) / (predHL$simulated_hl + 0.1))
predHL$log2DiffTrue = log2((predHL$score + 0.1) / (predHL$true_hl + 0.1))
rmseSim = sqrt(sum((predHL$simulated_hl - predHL$score) ^ 2) / nrow(predHL))
rmseTrue = sqrt(sum((predHL$true_hl - predHL$score) ^ 2) / nrow(predHL))
avgHL = mean(predHL$true_hl)

predHLUniq = predHL[predHL$multiMapCount == 0,]
predHLMulti = predHL[predHL$multiMapCount > 0,]

#ggplot(predHLUniq,aes(x=readsCPM,y=log2Diff)) + stat_binhex()
head(predHLUniq)

pdf(output, height = 6, width = 9)
plot(0, main=paste0("Unique UTRs (", nrow(predHLUniq), ")\nAvg. HL: ", round(avgHL), ", RMSE: ", round(rmseSim)), pch=4, xlim=c(min(predHLUniq$readsCPM), max(predHLUniq$readsCPM)), ylim=c(-6,6), xlab="couts per million (reads)", ylab="log2 FC (half-lifes)", type="n")
points(predHLUniq$readsCPM, predHLUniq$log2DiffSim, pch=1, col="#00000033")
abline(h=0, lty=2, col="grey")
plot(0, main=paste0("Multimapper UTRs (", nrow(predHLMulti) ,")\nAvg. HL: ", round(avgHL), ", RMSE: ", round(rmseSim)), pch=4, xlim=c(min(predHLUniq$readsCPM), max(predHLUniq$readsCPM)), ylim=c(-6,6), xlab="couts per million (reads)", ylab="log2 FC (half-lifes)", type="n")
points(predHLMulti$readsCPM, predHLMulti$log2DiffSim, pch=1, col="#00000033")
abline(h=0, lty=2, col="grey")

plot(0, main=paste0("Unique UTRs (", nrow(predHLUniq), ")\nAvg. HL: ", round(avgHL), ", RMSE: ", round(rmseSim)), pch=4, xlim=c(min(predHLUniq$true_hl), max(predHLUniq$true_hl)), ylim=c(-6,6), xlab="couts per million (reads)", ylab="log2 FC (half-lifes)", type="n")
points(predHLUniq$true_hl, predHLUniq$log2DiffSim, pch=1, col="#00000033")
abline(h=0, lty=2, col="grey")
plot(0, main=paste0("Multimapper UTRs (", nrow(predHLMulti) ,")\nAvg. HL: ", round(avgHL), ", RMSE: ", round(rmseSim)), pch=4, xlim=c(min(predHLUniq$true_hl), max(predHLUniq$true_hl)), ylim=c(-6,6), xlab="couts per million (reads)", ylab="log2 FC (half-lifes)", type="n")
points(predHLMulti$true_hl, predHLMulti$log2DiffSim, pch=1, col="#00000033")
abline(h=0, lty=2, col="grey")


#plot(0, main=paste0("Multimapper UTRs (", nrow(predHLMulti) ,")\nAvg. HL: ", round(avgHL), ", RMSE: ", round(rmseSim)), pch=4, xlim=c(min(predHLUniq$multiperc), max(predHLUniq$multiperc)), ylim=c(-6,6), xlab="couts per million (reads)", ylab="log2 FC (half-lifes)", type="n")
#points(predHLMulti$multiperc, predHLMulti$log2DiffSim, pch=1, col="#00000033")
#abline(h=0, lty=2, col="grey")


#lim = max(predHLUniq$simulated_hl) * 1.25
lim = 1440
corr = cor(predHLUniq$simulated_hl, predHLUniq$score)
plot(predHLUniq$simulated_hl ~ predHLUniq$score, main=paste0("Simulated vs. SlamDunk (unique)\nPearson: ", round(corr, digits = 4)), xlim=c(0, lim), ylim=c(0, lim), ylab="Half-life (simulated)", xlab="Half-Life (slamDunk)", col="#00000033")
abline(a = 0, b = 1, col="grey", lty=2)

corr = cor(predHLMulti$simulated_hl, predHLMulti$score)
plot(predHLMulti$simulated_hl ~ predHLMulti$score, main=paste0("Simulated vs. SlamDunk (multimapper)\nPearson: ", round(corr, digits = 4)), xlim=c(0, lim), ylim=c(0, lim), ylab="Half-life (simulated)", xlab="Half-Life (slamDunk)", col="#00000033")
abline(a = 0, b = 1, col="grey", lty=2)


corr = cor(predHLUniq$true_hl, predHLUniq$score)
plot(predHLUniq$true_hl ~ predHLUniq$score, main=paste0("True vs. SlamDunk (unique)\nPearson: ", round(corr, digits = 4)), xlim=c(0, lim), ylim=c(0, lim), ylab="Half-life (true)", xlab="Half-Life (slamDunk)", col="#00000033")
abline(a = 0, b = 1, col="grey", lty=2)

corr = cor(predHLMulti$true_hl, predHLMulti$score)
plot(predHLMulti$true_hl ~ predHLMulti$score, main=paste0("True vs. SlamDunk (multimapper)\nPearson: ", round(corr, digits = 4)), xlim=c(0, lim), ylim=c(0, lim), ylab="Half-life (true)", xlab="Half-Life (slamDunk)", col="#00000033")
abline(a = 0, b = 1, col="grey", lty=2)


dev.off()

#ggplot(predHLUniq,aes(x=simulated_hl,y=log2Diff)) + geom_point(alpha = 0.3)
#p = p + stat_binhex(bins=100)
#p = p
#ggplot(predHLMulti,aes(x=simulated_hl,y=log2Diff)) + stat_binhex(bins=100)



write.table(tmp, missing, quote = F, row.names = F, col.names = T)

#!/usr/bin/env Rscript

# Plot overall conversion rates per UTR

# Copyright (c) 2015 Tobias Neumann, Philipp Rescheneder.
#
# This file is part of Slamdunk.
#
# Slamdunk is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# Slamdunk is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

library(getopt)

spec = matrix(c(
				'help'      , 'h', 0, "logical","print the usage of the command",
				'rateTab', "f", 2,"character","tsv table of rate files",
				'outputFile', "O", 2,"character","output pdf file name"
		),ncol = 5,byrow=T)

opt = getopt(spec)

if ( !is.null(opt$help) || length(opt)==1 ) {
	#get the script name
	cmd = commandArgs(FALSE)
	self = strsplit(cmd[grep("--file",cmd)],"=")[[1]][2]
	cat(basename(self),": Create mismatch plots from rate tabs.\n\n")
	#print a friendly message and exit with a non-zero error code
	cat(getopt(spec,command = self,usage=T))
	q(status=1);
}


if ( is.null(opt$rateTab) ) stop("arg rateTab must be specified")
if ( is.null(opt$outputFile) ) { opt$outputFile = "out.pdf" }

library(ggplot2)
library(gridExtra)

rates = read.table(opt$rateTab,stringsAsFactors=FALSE,col.names = c("sample","file"), comment.char = "")

pdf(opt$outputFile)

plotList = list()

for (i in 1:nrow(rates)) {
	curTab = read.delim(rates$file[i],stringsAsFactors=FALSE,comment.char='#')

	plusTab = curTab[curTab$Strand == "+",]
	minusTab = curTab[curTab$Strand == "-",]

	# "Name"      "Chr"       "Start"     "End"       "Strand"    "ReadCount"
	# "A_A"       "A_C"       "A_G"       "A_T"       "A_N"       "C_A"
	# "C_C"       "C_G"       "C_T"       "C_N"       "G_A"       "G_C"
	# "G_G"       "G_T"       "G_N"       "T_A"       "T_C"       "T_G"
	# "T_T"       "T_N"       "N_A"       "N_C"       "N_G"       "N_T"
	# "N_N"

	names(minusTab) = c("Name", "Chr", "Start", "End", "Strand", "ReadCount",
			"T_T", "T_G", "T_C", "T_A", "NNN", "G_T",
			"G_G", "G_C", "G_A", "NNN", "C_T", "C_G",
			"C_C", "C_A", "NNN", "A_T", "A_G", "A_C",
			"A_A", "NNN", "NNN", "NNN", "NNN", "NNN",
			"NNN")

	plusTab = plusTab[,c(1,grep("N",names(plusTab),invert=TRUE))]
	minusTab = minusTab[,grep("NNN",names(minusTab),invert=TRUE)]

	plusTab = plusTab[,c(-1,-2,-3,-4,-5,-6)]
	plusTab = plusTab[rowSums(plusTab) > 0,]

	plusTab$Asum = plusTab$A_A + plusTab$A_C + plusTab$A_G + plusTab$A_T
	plusTab$Csum = plusTab$C_A + plusTab$C_C + plusTab$C_G + plusTab$C_T
	plusTab$Gsum = plusTab$G_A + plusTab$G_C + plusTab$G_G + plusTab$G_T
	plusTab$Tsum = plusTab$T_A + plusTab$T_C + plusTab$T_G + plusTab$T_T

	plusTab$A_A = plusTab$A_A / plusTab$Asum
	plusTab$A_C = plusTab$A_C / plusTab$Asum
	plusTab$A_G = plusTab$A_G / plusTab$Asum
	plusTab$A_T = plusTab$A_T / plusTab$Asum

	plusTab$C_A = plusTab$C_A / plusTab$Csum
	plusTab$C_C = plusTab$C_C / plusTab$Csum
	plusTab$C_G = plusTab$C_G / plusTab$Csum
	plusTab$C_T = plusTab$C_T / plusTab$Csum

	plusTab$G_A = plusTab$G_A / plusTab$Gsum
	plusTab$G_C = plusTab$G_C / plusTab$Gsum
	plusTab$G_G = plusTab$G_G / plusTab$Gsum
	plusTab$G_T = plusTab$G_T / plusTab$Gsum

	plusTab$T_A = plusTab$T_A / plusTab$Tsum
	plusTab$T_C = plusTab$T_C / plusTab$Tsum
	plusTab$T_G = plusTab$T_G / plusTab$Tsum
	plusTab$T_T = plusTab$T_T / plusTab$Tsum

	plusTab = plusTab[,grep("sum",names(plusTab),invert=TRUE)]

	plusTab = plusTab * 100

	minusTab = minusTab[,c(-1,-2,-3,-4,-5,-6)]
	minusTab = minusTab[rowSums(minusTab) > 0,]

	minusTab$Asum = minusTab$A_A + minusTab$A_C + minusTab$A_G + minusTab$A_T
	minusTab$Csum = minusTab$C_A + minusTab$C_C + minusTab$C_G + minusTab$C_T
	minusTab$Gsum = minusTab$G_A + minusTab$G_C + minusTab$G_G + minusTab$G_T
	minusTab$Tsum = minusTab$T_A + minusTab$T_C + minusTab$T_G + minusTab$T_T

	minusTab$A_A = minusTab$A_A / minusTab$Asum
	minusTab$A_C = minusTab$A_C / minusTab$Asum
	minusTab$A_G = minusTab$A_G / minusTab$Asum
	minusTab$A_T = minusTab$A_T / minusTab$Asum

	minusTab$C_A = minusTab$C_A / minusTab$Csum
	minusTab$C_C = minusTab$C_C / minusTab$Csum
	minusTab$C_G = minusTab$C_G / minusTab$Csum
	minusTab$C_T = minusTab$C_T / minusTab$Csum

	minusTab$G_A = minusTab$G_A / minusTab$Gsum
	minusTab$G_C = minusTab$G_C / minusTab$Gsum
	minusTab$G_G = minusTab$G_G / minusTab$Gsum
	minusTab$G_T = minusTab$G_T / minusTab$Gsum

	minusTab$T_A = minusTab$T_A / minusTab$Tsum
	minusTab$T_C = minusTab$T_C / minusTab$Tsum
	minusTab$T_G = minusTab$T_G / minusTab$Tsum
	minusTab$T_T = minusTab$T_T / minusTab$Tsum

	minusTab = minusTab[,grep("sum",names(minusTab),invert=TRUE)]

	minusTab = minusTab * 100

	plotTab = rbind(plusTab, minusTab)

	plotTab = plotTab[,c("A_C","A_G","A_T","C_A","C_G","C_T","G_A","G_C","G_T","T_A","T_C","T_G")]
	quantiles = lapply(plotTab, function(x) {
				return(quantile(x, na.rm=TRUE, p=0.75) + 1.5 * IQR(x, na.rm=TRUE))
			})

	ymax = ceiling(max(unlist(quantiles)))

	plotTab = rbind(
			data.frame(class = "A_C", values = plotTab$A_C),
			data.frame(class = "A_G", values = plotTab$A_G),
			data.frame(class = "A_T", values = plotTab$A_T),
			data.frame(class = "C_A", values = plotTab$C_A),
			data.frame(class = "C_G", values = plotTab$C_G),
			data.frame(class = "C_T", values = plotTab$C_T),
			data.frame(class = "G_A", values = plotTab$G_A),
			data.frame(class = "G_C", values = plotTab$G_C),
			data.frame(class = "G_T", values = plotTab$G_T),
			data.frame(class = "T_A", values = plotTab$T_A),
			data.frame(class = "T_C", values = plotTab$T_C),
			data.frame(class = "T_G", values = plotTab$T_G)
	)

	plotTab$highlight = "no"
	plotTab$highlight[plotTab$class == "T_C"] = "yes"
	plotTab$class = sub("_", ">", plotTab$class)
	plotTab$group = "A"
	plotTab$group[plotTab$class %in% c("C>A","C>G","C>T")] = "C"
	plotTab$group[plotTab$class %in% c("G>A","G>C","G>T")] = "G"
	plotTab$group[plotTab$class %in% c("T>A","T>C","T>G")] = "T"

	plotTab = plotTab[!is.na(plotTab$values),]

	curPlot = ggplot(plotTab, aes(x=class,y=values,fill=highlight,col=highlight)) + stat_boxplot(geom ='errorbar') + geom_boxplot(outlier.shape = NA,lwd=0.8,fatten=2) + facet_grid(~group, scales="free", space="free") + xlab("") + ylab("Mutation rate per UTR base [%]") +
			scale_fill_manual(values=c("white","white")) + scale_color_manual(values=c("black", "red")) + theme(axis.ticks.x = element_blank(), legend.position = "none")

	plotList[[length(plotList)+1]] <- curPlot + ylim(0,ymax) + ggtitle(rates$sample[i])

	anovaTest = aov(values ~ class, data = plotTab)
	print(paste("Sample: ",rates$sample[i],sep=""))
	print(TukeyHSD(x = anovaTest, 'class', conf.level = 0.95)$class)

}

do.call(grid.arrange,  plotList)

dev.off()

#signal success and exit.
q(status=0)

#!/usr/bin/env Rscript

# Plot PCA based on readcounts in UTRs

# Copyright (c) 2015 Tobias Neumann, Philipp Rescheneder.
#
# This file is part of Slamdunk.
#
# Slamdunk is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# Slamdunk is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

library(getopt)

spec = matrix(c(
  'help'      , 'h', 0, "logical","print the usage of the command",
  'fileTab', "f", 2,"character","tsv table of rate files",
  'outputPDF', "O", 2,"character","output pdf file name",
  'outputPCA', "P", 2,"character","output PCA transformations file name"
),ncol = 5,byrow=T)

opt = getopt(spec)

if ( !is.null(opt$help) || length(opt)==1 ) {
  #get the script name
  cmd = commandArgs(FALSE)
  self = strsplit(cmd[grep("--file",cmd)],"=")[[1]][2]
  cat(basename(self),": Create mismatch plots from rate tabs.\n\n")
  #print a friendly message and exit with a non-zero error code
  cat(getopt(spec,command = self,usage=T))
  q(status=1);
}


if ( is.null(opt$fileTab) ) stop("arg fileTab must be specified")
if ( is.null(opt$outputPDF) ) { opt$outputFile = "out.pdf" }

library(ggplot2)

samples = read.table(opt$fileTab,stringsAsFactors=FALSE,col.names = c("sample","file"), comment.char = "")

if (nrow(samples) <= 1) {
	cat('# slamdunk PCA\n',  file=opt$outputPCA)
	cat(paste(samples$sample,0,"0\n",sep="\t"),append=TRUE,file=opt$outputPCA)
	#signal success and exit.
	q(status=0)
}

countsList = list()

for (i in 1:nrow(samples)) {
  curTab = read.delim(samples$file[i],stringsAsFactors=FALSE, comment.char="#")

  countsList[[samples$sample[i]]] = curTab$TcReadCount

}

countMatrix = do.call(cbind, countsList)

variances = apply(countMatrix, 1, var)

sel = order(variances, decreasing=TRUE)[seq_len(min(500, length(variances)))]

pca = prcomp(t(countMatrix[sel,]))

PoV = pca$sdev ^ 2 / sum(pca$sdev ^ 2)

plotTab = data.frame(sample = row.names(pca$x), PC1 = pca$x[,1], PC2 = pca$x[,2])

pdf(opt$outputPDF)

ggplot(plotTab, aes(x=PC1, y=PC2, color = sample)) + geom_point(size = 3) +
  xlab(paste("PC1 (", round(PoV[1],digits=2), " % variance)",sep="")) +
  ylab(paste("PC2 (", round(PoV[2],digits=2), " % variance)",sep="")) +
  theme(legend.position="bottom", legend.title=element_blank()) + ggtitle("Slamdunk PCA")

dev.off()

cat('# slamdunk PCA\n',  file=opt$outputPCA)
write.table(plotTab,file=opt$outputPCA,append=TRUE,quote=FALSE,sep="\t",row.names=FALSE,col.names=FALSE)

#signal success and exit.
q(status=0)

#!/usr/bin/env Rscript

# Copyright (c) 2015 Tobias Neumann, Philipp Rescheneder.
#
# This file is part of Slamdunk.
#
# Slamdunk is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# Slamdunk is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

library(getopt)

spec = matrix(c(
  'help'      , 'h', 0, "logical","print the usage of the command",
  'simulated', "s", 2,"character","Comma seperated list of simulated files",
  'slamdunk', "f", 2,"character","Comma seperated list of SlamDunk results",
  'timepoints', "t", 2,"character","Comma seperated list of time points",
  'bed', "b", 2,"character","BED file containing half lifes",
  'output', "o", 2,"character","Output pdf",
  'conversionrate', "c", 2,"character","Simulated conversion rate"
),ncol = 5,byrow=T)

opt = getopt(spec)

if ( !is.null(opt$help) || length(opt)==4 ) {
  #get the script name
  cmd = commandArgs(FALSE)
  self = strsplit(cmd[grep("--file",cmd)],"=")[[1]][2]
  cat(basename(self),": Create mismatch plots from rate tabs.\n\n")
  #print a friendly message and exit with a non-zero error code
  cat(getopt(spec,command = self,usage=T))
  q(status=1);
}


if ( is.null(opt$simulated) ) stop("arg simulated must be specified")
if ( is.null(opt$slamdunk) ) stop("arg slamdunk must be specified")
if ( is.null(opt$output) ) stop("arg output must be specified")
if ( is.null(opt$timepoints) ) stop("arg timepoints must be specified")
if ( is.null(opt$bed) ) stop("arg bed specified")
if ( is.null(opt$conversionrate) ) { opt$conversionrate = 0.03 }

simulatedFiles = opt$simulated
#simulatedFiles = "/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/pooja_UTR_annotation_examples_1_0min_utrsummary.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/pooja_UTR_annotation_examples_2_15min_utrsummary.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/pooja_UTR_annotation_examples_3_30min_utrsummary.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/pooja_UTR_annotation_examples_4_60min_utrsummary.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/pooja_UTR_annotation_examples_5_180min_utrsummary.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/pooja_UTR_annotation_examples_6_360min_utrsummary.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/pooja_UTR_annotation_examples_7_720min_utrsummary.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/pooja_UTR_annotation_examples_8_1440min_utrsummary.csv"
#simulatedFiles = "/project/ngs/philipp/slamdunk-analysis/simulation/simulation_2/pooja_UTR_annotation_examples_sample_1_0min_utrsummary.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_2/pooja_UTR_annotation_examples_sample_2_15min_utrsummary.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_2/pooja_UTR_annotation_examples_sample_3_30min_utrsummary.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_2/pooja_UTR_annotation_examples_sample_4_60min_utrsummary.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_2/pooja_UTR_annotation_examples_sample_5_180min_utrsummary.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_2/pooja_UTR_annotation_examples_sample_6_360min_utrsummary.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_2/pooja_UTR_annotation_examples_sample_7_720min_utrsummary.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_2/pooja_UTR_annotation_examples_sample_8_1440min_utrsummary.csv"

slamDunkFiles = opt$slamdunk
#slamDunkFiles = "/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_1_0min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_2_15min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_3_30min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_4_60min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_5_180min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_6_360min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_7_720min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_8_1440min_reads_slamdunk_mapped_filtered_tcount.csv"
#slamDunkFiles = "/project/ngs/philipp/slamdunk-analysis/simulation/simulation_2/slamdunk/count/pooja_UTR_annotation_examples_sample_1_0min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_2/slamdunk/count/pooja_UTR_annotation_examples_sample_2_15min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_2/slamdunk/count/pooja_UTR_annotation_examples_sample_3_30min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_2/slamdunk/count/pooja_UTR_annotation_examples_sample_4_60min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_2/slamdunk/count/pooja_UTR_annotation_examples_sample_5_180min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_2/slamdunk/count/pooja_UTR_annotation_examples_sample_6_360min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_2/slamdunk/count/pooja_UTR_annotation_examples_sample_7_720min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_2/slamdunk/count/pooja_UTR_annotation_examples_sample_8_1440min_reads_slamdunk_mapped_filtered_tcount.csv"

filesSimulated = as.character(ordered(strsplit(simulatedFiles, ",")[[1]]))
filesSlamDunk = as.character(ordered(strsplit(slamDunkFiles, ",")[[1]]))
outputFile = opt$output
#outputFile = "/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/eval/halflife_per_gene_eval_plots.pdf"
#timesParameter = "0,15,30,60,180,360,720,1440"
timesParameter = opt$timepoints
times = as.numeric(strsplit(timesParameter, ",")[[1]])
times = times / 60
#bedFile = "/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/pooja_UTR_annotation_examples_original_utrs.bed"
#bedFile = "/project/ngs/philipp/slamdunk-analysis/simulation/simulation_2/finalAnnotation_test_cut_chrM_correct_100_original_utrs.bed"
bedFile = opt$bed
#conversionRate = 0.03
conversionRate = as.numeric(opt$conversionrate)

computeHalfLife <- function(rates, timepoints) {
  # Infere half life from data
  a_start<-max(rates) #param a is the y value when x=0
  k_start = log(2, base = exp(1))/5

  halfLifePred = NA
  C = NA
  k = NA

  tryCatch( {
    fit = nls(rates ~ a*(1-exp(-k*(timepoints))), start=list(a=a_start,k=k_start))
    halfLifePred = log(2, base = exp(1))/coef(fit)[2] * 60
    C = coef(fit)[1]
    k = coef(fit)[2]
  }, error=function(e){})

  c(halfLifePred, C, k)
}

mergeRates <- function(times, files, perRead) {
  mergedRates = data.frame()
  for(i in 1:length(times)) {
    time = times[i]
    #print(time)
    simDataFile = files[i]
    simulation = read.table(simDataFile)
    colnames(simulation) = c("chr", "start", "stop", "name", "strand", "conversionRate", "readsCPM", "tCount", "tcCount", "readCount", "convertedReads", "multiMapCount")
    if(nrow(mergedRates) == 0) {
      mergedRates = simulation[, c("chr", "start", "stop", "name", "strand")]
      if(perRead == TRUE) {
        mergedRates$conversionRate = simulation$convertedReads / simulation$readCount
      } else {
        mergedRates$conversionRate = simulation$conversionRate
      }
    } else {
      if(perRead == TRUE) {
        mergedRates = cbind(mergedRates, simulation$convertedReads / simulation$readCount)
      } else {
        mergedRates = cbind(mergedRates, simulation$conversionRate)
      }
    }
  }
  colnames(mergedRates) = c("chr", "start", "stop", "name", "strand", times)
  mergedRates
}

bed = read.table(bedFile)
colnames(bed) = c("char", "start", "stop", "name", "score", "strand")



perRead = F
slamDunkMergedRates = mergeRates(times, filesSlamDunk, perRead)
simMergedRates = mergeRates(times, filesSimulated, perRead)

pageNumber = 1
#outputFile = "~/test.pdf"
#pdf(outputFile, height=6, width=9)
pdf(paste0(outputFile, "_page_", pageNumber, ".pdf"), height=6, width=9)
for(utr in 1:nrow(slamDunkMergedRates)) {
  #utr = 1
  pulseSlamDunk = data.frame(y = as.numeric(t(slamDunkMergedRates[utr, 6:(5 + length(times))])[,1]), x = times)
  pulseSimulated = data.frame(y = as.numeric(t(simMergedRates[utr, 6:(5 + length(times))])[,1]), x = times)
  #yLim = max(max(pulseSlamDunk$y), max(pulseSimulated$y))
  yLim = conversionRate * 1.25
  yLab = "conversion rate"
  if(perRead) {
    yLab = "% of T->C reads"
  }

  # Infere half life from data
  halfLifeResultSlamDunk = computeHalfLife(pulseSlamDunk$y, pulseSlamDunk$x)
  halfLifePred = halfLifeResultSlamDunk[1]
  halfLifeResultSimulated = computeHalfLife(pulseSimulated$y, pulseSimulated$x)
  halfLifeSim = halfLifeResultSimulated[1]
  halfLifeTruth = bed[utr, ]$score


  plot(0, type="n", main=paste0(slamDunkMergedRates[utr, ]$name, "\n half life: ", round(halfLifeTruth, digits = 0), " (truth), ", round(halfLifeSim, digits = 0), " (sim), ", round(halfLifePred, digits = 0)," (slamDunk)"), xlab="Time (hours)", ylab=yLab, ylim=c(0, yLim), xlim=c(times[1], times[length(times)]), pch=4)
  lines(pulseSimulated$x, pulseSimulated$y, type="p", col="green", lty=1, pch=4)
  lines(pulseSlamDunk$x, pulseSlamDunk$y, type="p", col="blue", lty=1, pch=4)
  legend("bottomright", c("rates (slamDunk)", "rates (simulated)", "slamDunk", "simulated", "truth"), col=c("blue", "green", "blue", "green", "grey"), lty=c(1, 1, 2, 2, 2), bty="n")


  t = 0:max(times)
  # Print truth
  lambda = log(2) / (halfLifeTruth / 60)
  lines((1 - exp(-lambda*t)) * conversionRate ~ t, type="l", lty=2, col="grey")
  # Print simulated
  lines((1 - exp(-halfLifeResultSimulated[3]*t)) * halfLifeResultSimulated[2] ~ t, type="l", lty=2, col="green")
  # Print slamDunk
  lines((1 - exp(-halfLifeResultSlamDunk[3]*t)) * halfLifeResultSlamDunk[2] ~ t, type="l", lty=2, col="blue")

  if(utr %% 100 == 0) {
    dev.off()
    pageNumber = pageNumber + 1
    pdf(paste0(outputFile, "_page_", pageNumber, ".pdf"), height=6, width=9)
    print(paste0(outputFile, "_page_", pageNumber, ".pdf"))
  }

}
dev.off()

#!/usr/bin/env Rscript

# Copyright (c) 2015 Tobias Neumann, Philipp Rescheneder.
#
# This file is part of Slamdunk.
#
# Slamdunk is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# Slamdunk is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

library(getopt)

spec = matrix(c(
  'help'      , 'h', 0, "logical","print the usage of the command",
  'simulated', "s", 2,"character","Comma seperated list of simulated files",
  'slamdunk', "f", 2,"character","Comma seperated lost of SlamDunk results",
  'output', "o", 2,"character","Output pdf",
  'conversionrate', "c", 2,"character","Simulated conversion rate"
),ncol = 5,byrow=T)

opt = getopt(spec)

if ( !is.null(opt$help) || length(opt)==3 ) {
  #get the script name
  cmd = commandArgs(FALSE)
  self = strsplit(cmd[grep("--file",cmd)],"=")[[1]][2]
  cat(basename(self),": Create mismatch plots from rate tabs.\n\n")
  #print a friendly message and exit with a non-zero error code
  cat(getopt(spec,command = self,usage=T))
  q(status=1);
}


if ( is.null(opt$simulated) ) stop("arg simulated must be specified")
if ( is.null(opt$slamdunk) ) stop("arg slamdunk must be specified")
if ( is.null(opt$output) ) stop("arg output must be specified")
if ( is.null(opt$conversionrate) ) { opt$conversionrate = 0.03 }

#simulatedFiles = "/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/pooja_UTR_annotation_examples_1_0min_utrsummary.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/pooja_UTR_annotation_examples_2_15min_utrsummary.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/pooja_UTR_annotation_examples_3_30min_utrsummary.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/pooja_UTR_annotation_examples_4_60min_utrsummary.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/pooja_UTR_annotation_examples_5_180min_utrsummary.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/pooja_UTR_annotation_examples_6_360min_utrsummary.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/pooja_UTR_annotation_examples_7_720min_utrsummary.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/pooja_UTR_annotation_examples_8_1440min_utrsummary.csv"
#slamDunkFiles = "/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_1_0min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_2_15min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_3_30min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_4_60min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_5_180min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_6_360min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_7_720min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_8_1440min_reads_slamdunk_mapped_filtered_tcount.csv"
#outputFile = "/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/eval/conversion_rate_per_gene_eval_plots.pdf"
#timesParameter = "0,15,30,60,180,360,720,1440"
#conversionRate = 0.03

simulatedFiles = opt$simulated
#simulatedFiles = "simulation_1/pooja_UTR_annotation_examples_sample_1_0min_utrsummary.csv,simulation_1/pooja_UTR_annotation_examples_sample_2_15min_utrsummary.csv,simulation_1/pooja_UTR_annotation_examples_sample_3_30min_utrsummary.csv,simulation_1/pooja_UTR_annotation_examples_sample_4_60min_utrsummary.csv,simulation_1/pooja_UTR_annotation_examples_sample_5_180min_utrsummary.csv,simulation_1/pooja_UTR_annotation_examples_sample_6_360min_utrsummary.csv,simulation_1/pooja_UTR_annotation_examples_sample_7_720min_utrsummary.csv,simulation_1/pooja_UTR_annotation_examples_sample_8_1440min_utrsummary.csv"
slamDunkFiles = opt$slamdunk
#slamDunkFiles = "simulation_1/slamdunk/count/pooja_UTR_annotation_examples_sample_1_0min_reads_slamdunk_mapped_filtered_tcount.csv,simulation_1/slamdunk/count/pooja_UTR_annotation_examples_sample_2_15min_reads_slamdunk_mapped_filtered_tcount.csv,simulation_1/slamdunk/count/pooja_UTR_annotation_examples_sample_3_30min_reads_slamdunk_mapped_filtered_tcount.csv,simulation_1/slamdunk/count/pooja_UTR_annotation_examples_sample_4_60min_reads_slamdunk_mapped_filtered_tcount.csv,simulation_1/slamdunk/count/pooja_UTR_annotation_examples_sample_5_180min_reads_slamdunk_mapped_filtered_tcount.csv,simulation_1/slamdunk/count/pooja_UTR_annotation_examples_sample_6_360min_reads_slamdunk_mapped_filtered_tcount.csv,simulation_1/slamdunk/count/pooja_UTR_annotation_examples_sample_7_720min_reads_slamdunk_mapped_filtered_tcount.csv,simulation_1/slamdunk/count/pooja_UTR_annotation_examples_sample_8_1440min_reads_slamdunk_mapped_filtered_tcount.csv"
filesSimulated = as.character(ordered(strsplit(simulatedFiles, ",")[[1]]))
filesSlamDunk = as.character(ordered(strsplit(slamDunkFiles, ",")[[1]]))
outputFile = opt$output
conversionRate = opt$conversionrate

pdf(outputFile, width = 15, height = 6)
for(timepoint in 1:length(filesSimulated)) {
  #timepoint = 5
  simDataFile = filesSimulated[timepoint]
  slamDunkFile = filesSlamDunk[timepoint]
  name = basename(simDataFile)

  simulation = read.table(simDataFile)
  colnames(simulation) = c("chr", "start", "stop", "name", "strand", "conversionRate", "readsCPM", "tCount", "tcCount", "readCount", "convertedReads", "multiMapCount")
  #simulation$coverage = (simulation$simulatedReads / (simulation$stop - simulation$start) * 50)
  simulation$convertedReadsRate = simulation$convertedReads / simulation$readCount

  slamdunk = read.table(slamDunkFile)
  colnames(slamdunk) = c("chr", "start", "stop", "name", "strand", "conversionRate", "readsCPM", "tCount", "tcCount", "readCount", "convertedReads", "multiMapCount")
  slamdunk$readsCPM_sim = simulation$readsCPM
  slamdunk$log2diff = log2((simulation$conversionRate + 0.0000001) / (slamdunk$conversionRate + 0.0000001))
  slamdunk$diff = (simulation$conversionRate - slamdunk$conversionRate)
  #slamdunk$convertedReadsRate = slamdunk$convertedReads / slamdunk$readCount
  #slamdunk$diffconvertedReadsRate = (simulation$convertedReads - slamdunk$convertedReads)
  #slamdunk$diffconvertedReadsRatediff = ((simulation$convertedReads / simulation$readCount) - (slamdunk$convertedReads / slamdunk$readCount))
  #plot(simulation$V11 ~ slamdunk$V6, xlim=c(0, 0.01), ylim=c(0, 0.01))

  par(mfrow=c(1,2))
  #yLim = max(abs(slamdunk$diffconvertedReadsRate))
  yLim = as.numeric(conversionRate)
  #boxplot(slamdunk$log2diff)
  slamDunkUniq = slamdunk[slamdunk$multiMapCount <= 0, ]
  slamDunkMulti = slamdunk[slamdunk$multiMapCount > 0, ]
  plot(slamDunkUniq$readsCPM_sim, slamDunkUniq$diff, main=name, pch=4, ylim=c(-yLim, yLim), ylab="conversion (sim) - conversion (slamdunk)", xlab="read counts per million")
  points(slamDunkMulti$readsCPM_sim, slamDunkMulti$diff, pch=4, col="red")
  abline(h=0, lty=2, col="grey")

  yLim = 4
  plot(slamDunkUniq$readsCPM_sim, slamDunkUniq$log2diff, main=name, pch=4, ylim=c(-yLim, yLim), ylab="log2(conversion (sim) / conversion (slamdunk))", xlab="read counts per million")
  points(slamDunkMulti$readsCPM_sim, slamDunkMulti$log2diff, pch=4, col="red")
  abline(h=0, lty=2, col="grey")
}
dev.off()

#!/usr/bin/env Rscript
# Script to evaluate Slamdunk count results
#
# Copyright (c) 2015 Tobias Neumann, Philipp Rescheneder.
#
# This file is part of Slamdunk.
#
# Slamdunk is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# Slamdunk is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

library(getopt)

spec = matrix(c(
  'help'      , 'h', 0, "logical","print the usage of the command",
  'simulated', "s", 2,"character","Summarized count file",
  'slamdunk', "d", 2,"character","Summarized count file",
  'output', "o", 2,"character","Output pdf"
),ncol = 5,byrow=T)

opt = getopt(spec)

if ( !is.null(opt$help) || length(opt)==1 ) {
  #get the script name
  cmd = commandArgs(FALSE)
  self = strsplit(cmd[grep("--file",cmd)],"=")[[1]][2]
  cat(basename(self),": Create mismatch plots from rate tabs.\n\n")
  #print a friendly message and exit with a non-zero error code
  cat(getopt(spec,command = self,usage=T))
  q(status=1);
}


if ( is.null(opt$simulated) ) stop("arg simulated must be specified")
if ( is.null(opt$slamdunk) ) stop("arg slamdunk must be specified")
if ( is.null(opt$output) ) stop("arg output must be specified")


rsme <- function(model, measure) {
  sqrt( mean( (model-measure)^2 , na.rm = TRUE ) )
}

#folder = "/project/ngs/philipp/slamdunk-analysis/simulation/simulation_6/"
#version = "slamdunk/"
#tcRatePerPosition = 0.024
#readLength = 50 - 12
#sampleNumber = 21
#cfactor = 1 - dbinom(0, round(readLength / 4), tcRatePerPosition)

simulatedFileRates = opt$simulated
#simulatedFileRates = "/project/libby/slamdunk-analysis/simulation/data/test_rates_full_cov50_rl88_1/utrsummary_all_samples_rates_reads.tsv"

slamDunkFile = opt$slamdunk
#slamDunkFile = "/project/libby/slamdunk-analysis/simulation/data/test_rates_full_cov50_rl88_1/slamdunk/count/tcounts_all_samples_rates.tsv"

outputFile = opt$output
outputFileCSV = paste0(outputFile, ".tsv")

simulatedRates = read.table(simulatedFileRates, header=T, sep="\t", stringsAsFactors = F)
slamDunkRates = read.table(slamDunkFile, header=T, sep="\t", stringsAsFactors = F)

# Should not be neccessary, but for large datasets some entries are lost.
# Keep all that is found in both
inBoth = intersect(simulatedRates$Name, slamDunkRates$Name)
simulatedRates = simulatedRates[simulatedRates$Name %in% inBoth,]
slamDunkRates = slamDunkRates[slamDunkRates$Name %in% inBoth,]

fixedColumns = 11
sampleNumber = ncol(simulatedRates) - fixedColumns + 1

sampleNames = colnames(simulatedRates)[fixedColumns:(fixedColumns + sampleNumber - 1)]
simulatedSamples = simulatedRates[, fixedColumns:(fixedColumns + sampleNumber - 1)]
slamDunkSamples = slamDunkRates[, fixedColumns:(fixedColumns + sampleNumber - 1)]

pdf(outputFile)
par(mfrow=c(2,1))
boxplot(simulatedSamples - slamDunkSamples, ylim=c(-1,1), names = sampleNames, ylab="Simulated - Slamdunk", xlab="Labeled Transcripts [%]", main="", las=2)
abline(h=0, lty=2, col="grey")

boxplot(log2((simulatedSamples + 0.001) / (slamDunkSamples  + 0.001)), names = sampleNames, ylab="log2(Simulated / Slamdunk)", xlab="Labeled Transcripts [%]", main="", las=2)
abline(h=0, lty=2, col="grey")

boxplot(simulatedSamples - slamDunkSamples, ylim=c(-0.1,0.1), names = sampleNames, ylab="Simulated - Slamdunk", xlab="Labeled Transcripts [%]", main="", las=2)
abline(h=0, lty=2, col="grey")

boxplot(log2((simulatedSamples + 0.001) / (slamDunkSamples  + 0.001)), ylim=c(-1,1), names = sampleNames, ylab="log2(Simulated / Slamdunk)", xlab="Labeled Transcripts [%]", main="", las=2)
abline(h=0, lty=2, col="grey")

merged = data.frame()
#rsmeTab = data.frame(File=character(), Rate=character(), RSME=character(), stringsAsFactors=F)
rsmeTab = matrix("", ncol=3, nrow=0)
for(currentSample in 0:(sampleNumber - 1)) {
  #currentSample = 0
  current = cbind(slamDunkRates[, c(1:fixedColumns - 1, fixedColumns + currentSample)], simulatedRates[, fixedColumns + currentSample])
  colnames(current) = c(colnames(slamDunkRates[, c(1:fixedColumns - 1)]), "Simulate", "Slamdunk")
  merged = rbind(merged, current)

  rsmeTab = rbind(rsmeTab, c(as.character(simulatedFileRates), as.character(substring(sampleNames[currentSample + 1], 2)), as.character(rsme(current$Simulate, current$Slamdunk))))
}

par(mfrow=c(1,1))
perr = round(rsme(merged$Simulate, merged$Slamdunk), digits = 4)
pcorr = round(cor(merged$Simulate, merged$Slamdunk), digits = 4)
plot(merged$Slamdunk,  merged$Simulate, xlim=c(0,1), ylim=c(0,1), pch=4, xlab="Simulated", ylab="Slamdunk", main=paste("Cor: ", pcorr, ", RMSE: ", perr))
abline(a = 0, b = 1, col="grey", lty=2)

plot(merged$avgTcontent, merged$Slamdunk - merged$Simulate, ylim=c(-1,1), pch=4)

plot(merged$avgReadsCPM, merged$Slamdunk - merged$Simulate, ylim=c(-1,1), pch=4)

plot(merged$avgMultimapper, merged$Slamdunk - merged$Simulate, ylim=c(-1,1), pch=4)

dev.off()

rsmeTab = rbind(rsmeTab, c(as.character(simulatedFileRates), as.character(-1), as.character(rsme(merged$Simulate, merged$Slamdunk))))

write.table(rsmeTab, outputFileCSV, sep = "\t", quote = F, row.names = F, col.names = T)

#!/usr/bin/env Rscript

# Script to overlap public database file
#
# Copyright (c) 2015 Tobias Neumann, Philipp Rescheneder.
#
# This file is part of Slamdunk.
#
# Slamdunk is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# Slamdunk is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

library(getopt)
library(ggplot2)
library(gridExtra)

spec = matrix(c(
				'help'      , 'h', 0, "logical","print the usage of the command",
				'rateTab', "f", 2,"character","tsv table of rate files",
				'name', "n", 2,"character","Sample name",
				'outputFile', "O", 2,"character","output pdf file name"
		),ncol = 5,byrow=T)

opt = getopt(spec)

if ( !is.null(opt$help) || length(opt)<1 ) {
	#get the script name
	cmd = commandArgs(FALSE)
	self = strsplit(cmd[grep("--file",cmd)],"=")[[1]][2]
	cat(basename(self),": Create mismatch plots from rate tabs.\n\n")
	#print a friendly message and exit with a non-zero error code
	cat(getopt(spec,command = self,usage=T))
	q(status=1);
}


if ( is.null(opt$rateTab) ) stop("arg rateTab must be specified")
if ( is.null(opt$name) ) { opt$outputFile = "Sample 1" }
if ( is.null(opt$outputFile) ) { opt$outputFile = "out.pdf" }

#rates = read.table(opt$rateTab,stringsAsFactors=FALSE,col.names = c("sample","file"), comment.char = "")

fileName = opt$rateTab
# file = "/project/libby/slamdunk-analysis/sra_example/rates/ERR1692138_slamdunk_mapped_filtered_overallrates.csv"
# file = "/project/libby/slamdunk-analysis/mareike/rates/AML_41-1_48h_Mll212207_37484.fastq_slamdunk_mapped_filtered_overallrates.csv"
sampleName = opt$name
# sampleName = "Sample 1"

pdf(opt$outputFile)

plotList = list()

#for (i in 1:nrow(rates)) {
	curTab = read.table(fileName,stringsAsFactors=FALSE)

	curTab[, c("A", "C", "G", "T")] <- curTab[, c("A", "C", "G", "T")]/rowSums(curTab[, c("A", "C", "G", "T")]) * 100
	curTab[, c("a", "c", "g", "t")] <- curTab[, c("a", "c", "g", "t")]/rowSums(curTab[, c("a", "c", "g", "t")])  * 100

	printTab = data.frame(rates=c(rep("AT",2),rep("AC",2),rep("AG",2),
					rep("TA",2),rep("TC",2),rep("TG",2),
					rep("CA",2),rep("CT",2),rep("CG",2),
					rep("GA",2),rep("GT",2),rep("GC",2)), strand = rep(c("+","-"),12),
			rate_percent = c(curTab["A","T"],curTab["A","t"],curTab["A","C"],curTab["A","c"],curTab["A","G"],curTab["A","g"],
					curTab["T","A"],curTab["T","a"],curTab["T","C"],curTab["T","c"],curTab["T","G"],curTab["T","g"],
					curTab["C","A"],curTab["C","a"],curTab["C","T"],curTab["C","t"],curTab["C","G"],curTab["C","g"],
					curTab["G","A"],curTab["G","a"],curTab["G","T"],curTab["G","t"],curTab["G","C"],curTab["G","c"])
	)


	#fwdATot = max(1, sum(curTab["A",c("A", "C", "G", "T", "N")]))
	#fwdCTot = max(1, sum(curTab["C",c("A", "C", "G", "T", "N")]))
	#fwdGTot = max(1, sum(curTab["G",c("A", "C", "G", "T", "N")]))
	#fwdTTot = max(1, sum(curTab["T",c("A", "C", "G", "T", "N")]))

	#revATot = max(1, sum(curTab["A",c("a", "c", "g", "t", "n")]))
	#revCTot = max(1, sum(curTab["C",c("a", "c", "g", "t", "n")]))
	#revGTot = max(1, sum(curTab["G",c("a", "c", "g", "t", "n")]))
	#revTTot = max(1, sum(curTab["T",c("a", "c", "g", "t", "n")]))

	#total = c(rep(c(fwdATot, revATot), 3), rep(c(fwdTTot, revTTot), 3), rep(c(fwdCTot, revCTot), 3), rep(c(fwdGTot, revGTot), 3) )

	#printTab$rate_percent = printTab$rate_percent / total * 100

	maxRatePercent = max(10, max(printTab$rate_percent) * 1.1)

	printTab$y = -0.3
	printTab[printTab$strand == "-", ]$y = printTab[printTab$strand == "-", ]$rate_percent + printTab[printTab$strand == "+", ]$rate_percent

	curPlot = qplot(x=rates, y=rate_percent, fill=strand,data=printTab) + ylim(-0.5,maxRatePercent) + geom_bar(stat="identity") + geom_text(aes(y = printTab$y, label = round(rate_percent,digits=2)), size = 3, hjust = 0.5, vjust = -0.50) + ylab("Rate percent %") + xlab(sampleName) +
			theme(text = element_text(size=12),axis.text.x = element_text(size=12))
	#curPlot + xlim(0,35)
	plotList[[length(plotList)+1]] <- curPlot #+ ylim(0.0,maxRatePercent)
#}

do.call(grid.arrange,  plotList)

dev.off()

#signal success and exit.
q(status=0)

#!/usr/bin/env Rscript
#
# Script to merge SlamDunk count files
#
# Copyright (c) 2015 Tobias Neumann, Philipp Rescheneder.
#
# This file is part of Slamdunk.
#
# Slamdunk is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# Slamdunk is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

library(getopt)

spec = matrix(c(
  'help'      , 'h', 0, "logical","print the usage of the command",
  'slamdunk', "f", 2,"character","Comma seperated list of SlamDunk results",
  'output', "o", 2,"character","Output tsv",
  'column', "c", 2,"character","Column or Expression used to summarize files",
  'columnname', "n", 2,"character","Index of meta data field to use as column name"
),ncol = 5,byrow=T)

opt = getopt(spec)

if ( !is.null(opt$help) || length(opt)==2 ) {
  #get the script name
  cmd = commandArgs(FALSE)
  self = strsplit(cmd[grep("--file",cmd)],"=")[[1]][2]
  cat(basename(self),": Create mismatch plots from rate tabs.\n\n")
  #print a friendly message and exit with a non-zero error code
  cat(getopt(spec,command = self,usage=T))
  q(status=1);
}

if ( is.null(opt$slamdunk) ) stop("arg slamdunk must be specified")
if ( is.null(opt$output) ) stop("arg output must be specified")
if ( is.null(opt$column) ) { opt$column = "TcReadCount / ReadCount" }
if ( is.null(opt$column) ) { opt$columnname = 2 }

slamDunkFiles = opt$slamdunk
#slamDunkFiles = "/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_7_720min_reads_slamdunk_mapped_filtered_tcount.tsv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_1_0min_reads_slamdunk_mapped_filtered_tcount.tsv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_6_360min_reads_slamdunk_mapped_filtered_tcount.tsv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_2_15min_reads_slamdunk_mapped_filtered_tcount.tsv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_8_1440min_reads_slamdunk_mapped_filtered_tcount.tsv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_3_30min_reads_slamdunk_mapped_filtered_tcount.tsv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_5_180min_reads_slamdunk_mapped_filtered_tcount.tsv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_4_60min_reads_slamdunk_mapped_filtered_tcount.tsv"
#slamDunkFiles = "ngm-20161027/count/34330_An312_wt-2n_mRNA-slamseq-autoquant_0h-R1.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34331_An312_wt-2n_mRNA-slamseq-autoquant_0.25h-R1.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34332_An312_wt-2n_mRNA-slamseq-autoquant_0.5h-R1.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34333_An312_wt-2n_mRNA-slamseq-autoquant_1h-R1.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34334_An312_wt-2n_mRNA-slamseq-autoquant_3h-R1.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34335_An312_wt-2n_mRNA-slamseq-autoquant_6h-R1.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34336_An312_wt-2n_mRNA-slamseq-autoquant_12h-R1.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34343_An312_wt-2n_mRNA-slamseq-autoquant_0h-R2.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34344_An312_wt-2n_mRNA-slamseq-autoquant_0.25h-R2.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34347_An312_wt-2n_mRNA-slamseq-autoquant_3h-R2.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34348_An312_wt-2n_mRNA-slamseq-autoquant_6h-R2.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34349_An312_wt-2n_mRNA-slamseq-autoquant_12h-R2.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34354_An312_wt-2n_mRNA-slamseq-autoquant_24h-R2.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34356_An312_wt-2n_mRNA-slamseq-autoquant_0h-R3.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34357_An312_wt-2n_mRNA-slamseq-autoquant_0.25h-R3.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34358_An312_wt-2n_mRNA-slamseq-autoquant_0.5h-R3.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34359_An312_wt-2n_mRNA-slamseq-autoquant_1h-R3.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34361_An312_wt-2n_mRNA-slamseq-autoquant_6h-R3.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34362_An312_wt-2n_mRNA-slamseq-autoquant_12h-R3.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34367_An312_wt-2n_mRNA-slamseq-autoquant_24h-R3.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34503_An312_wt-2n_mRNA-slamseq-autoquant_0.5h-R2.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34504_An312_wt-2n_mRNA-slamseq-autoquant_1h-R2.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34505_An312_wt-2n_mRNA-slamseq-autoquant_3h-R3.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34506_An312_wt-2n_mRNA-slamseq-autoquant_24h-R1.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34507_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-R1.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34508_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-R2.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34509_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-R3.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34510_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-0.25h-R1.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34511_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-0.25h-R2.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34512_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-0.25h-R3.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34513_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-0.5h-R1.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34514_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-0.5h-R2.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34515_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-0.5h-R3.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34516_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-1h-R1.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34517_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-1h-R2.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34518_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-1h-R3.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34519_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-3h-R1.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34520_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-3h-R2.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34521_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-3h-R3.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34522_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-6h-R1.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34523_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-6h-R2.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34524_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-6h-R3.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34525_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-12h-R1.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34526_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-12h-R2.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34527_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-12h-R3.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34528_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-24h-R1.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34529_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-24h-R2.fq_slamdunk_mapped_filtered_tcount.tsv,ngm-20161027/count/34530_An312_wt-2n_mRNA-slamseq-autoquant_24h-star-24h-R3.fq_slamdunk_mapped_filtered_tcount.tsv"
filesSlamDunk = as.character(ordered(strsplit(slamDunkFiles, ",")[[1]]))
outputFile = opt$output
#outputFile = "/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/eval/halflife_per_gene_eval_plots.tsv"
evalExpression = opt$column
#evalExpression = "TcReadCount / ReadCount"
columnName = as.integer(opt$columnname)
#columnName = 2

readMeatInfo <- function(fileName) {
  #fileName = filesSlamDunk[1]
  sampleInfo = read.table(fileName, nrows = 1, comment.char = "")
  version = paste(lapply(sampleInfo[1,1:3], as.character), collapse = '\t')
  sampleID = as.character(sampleInfo[1, ]$V7)
  sampleName = as.character(sampleInfo[1, ]$V6)
  sampleType = as.character(sampleInfo[1, ]$V8)
  sampleTime = as.numeric(sampleInfo[1, ]$V9)
  sampleInfo = read.table(fileName, nrows = 1, skip = 1, comment.char = "")
  annotationMD5 = as.character(sampleInfo[1, ]$V3)
  annotationName = as.character(sampleInfo[1, ]$V2)
  c(sampleID, sampleName, sampleType, sampleTime, annotationName, annotationMD5, version)
}

sampleNumber = length(filesSlamDunk)
mergedRates = data.frame()

annotationName = ""
annotationMD5 = ""
version = ""
IDs = c()

# Merge rates from all samples
for(i in 1:length(filesSlamDunk)) {
  #i = 1
  file = filesSlamDunk[i]
  meta = readMeatInfo(file)
  sampleName = meta[columnName]

  if(i == 1) {
    version = meta[7]
    annotationName = meta[5]
    annotationMD5 = meta[6]
  } else {
    if(annotationMD5 != meta[6]) {

    }
  }

  IDs = c(IDs, as.numeric(meta[1]))
  data = read.table(file, header = T)
  if(i == 1) {
    mergedRates = data[, c(1:6)]
    mergedRates$avgReadsCPM = data$ReadsCPM
    mergedRates$avgMultimapper = data$multimapCount
    mergedRates$avgTcontent = data$Tcontent
    mergedRates$avgCoverageOnTs = data$CoverageOnTs
  } else {
    mergedRates$avgReadsCPM = mergedRates$avgReadsCPM + data$ReadsCPM
    mergedRates$avgMultimapper = mergedRates$avgMultimapper + data$multimapCount
    mergedRates$avgTcontent = mergedRates$avgTcontent + data$Tcontent
    mergedRates$avgCoverageOnTs = mergedRates$avgCoverageOnTs + data$CoverageOnTs
  }
  #if(perRead == T) {
  attach(data)
  #mergedRates[,sampleName] = data$TcReadCount / data$ReadCount
  mergedRates[,sampleName] = eval(parse(text=evalExpression))
  detach(data)
  mergedRates[data$ReadCount == 0,sampleName] = 0
  #} else {
  #  mergedRates[,sampleName] = data$ConversionRate
  #}
}
# compute average CPM and multimapper per UTR
mergedRates$avgReadsCPM = mergedRates$avgReadsCPM / sampleNumber
mergedRates$avgMultimapper = mergedRates$avgMultimapper / sampleNumber
mergedRates$avgTcontent = mergedRates$avgTcontent / sampleNumber
mergedRates$avgCoverageOnTs = mergedRates$avgCoverageOnTs / sampleNumber

#head(mergedRates)
# Sort columns by sample name
colNumber = length(colnames(mergedRates))
firstSampleColumn = (colNumber - sampleNumber + 1)
sampleNames = colnames(mergedRates)[firstSampleColumn:colNumber]
sampleColumnOrder = order(IDs)
mergedRates = mergedRates[, c(1:(firstSampleColumn - 1), (sampleColumnOrder + firstSampleColumn - 1))]

#head(mergedRates)

# Write to output file
con <- file(outputFile, open="wt")
writeLines(version, con)
writeLines(paste0("#Annotation:\t", annotationName, "\t", annotationMD5), con)
writeLines(paste0("#Expression:\t", evalExpression), con)
write.table(mergedRates, con, sep = "\t", quote = F, row.names = F, col.names = T)
close(con)

#!/usr/bin/env Rscript

# Script to look at SNP distributions along UTRs ranked by # T>C SNPs
#
# Copyright (c) 2015 Tobias Neumann, Philipp Rescheneder.
#
# This file is part of Slamdunk.
#
# Slamdunk is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# Slamdunk is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

library(getopt)

spec = matrix(c(
				'help'      , 'h', 0, "logical","print the usage of the command",
				'inputFile', "i", 2,"character","tsv table of snp vs tc count files",
				'coverageCutoff', "c", 2,"numeric","coverage cutoff for calling variants",
				'variantFraction', "v", 2,"numeric","variant fraction cutoff for calling variants",
				'outputFile', "o", 2,"character","output pdf file name"
		),ncol = 5,byrow=T)

opt = getopt(spec)

if ( !is.null(opt$help) || length(opt)==1 ) {
	#get the script name
	cmd = commandArgs(FALSE)
	self = strsplit(cmd[grep("--file",cmd)],"=")[[1]][2]
	cat(basename(self),": Create mismatch plots from rate tabs.\n\n")
	#print a friendly message and exit with a non-zero error code
	cat(getopt(spec,command = self,usage=T))
	q(status=1);
}


if ( is.null(opt$inputFile) ) stop("arg rateTab must be specified")
if ( is.null(opt$outputFile) ) { opt$outputFile = "out.pdf" }
if ( is.null(opt$coverageCutoff) ) { opt$coverageCutoff = 0 }
if ( is.null(opt$variantFraction) ) { opt$variantFraction = 0 }

tricubeMovingAverage <-function (x, span = 0.5, full.length = TRUE) {

	n <- length(x)
	width <- span * n
	hwidth <- as.integer(width%/%2L)
	if (hwidth <= 0L)
		return(x)
	width <- 2L * hwidth + 1L
	u <- seq(from = -1, to = 1, length = width) * width/(width +
				1)
	tricube.weights <- (1 - abs(u)^3)^3
	tricube.weights <- tricube.weights/sum(tricube.weights)
	if (!full.length)
		return(as.vector(filter(x, tricube.weights), mode = "numeric")[(hwidth + 1):(n - hwidth)])
	z <- numeric(hwidth)
	x <- as.vector(filter(c(z, x, z), tricube.weights), mode = "numeric")[(hwidth + 1):(n + hwidth)]
	cw <- cumsum(tricube.weights)
	x[1:hwidth] <- x[1:hwidth]/cw[(width - hwidth):(width - 1)]
	x[(n - hwidth + 1):n] <- x[(n - hwidth + 1):n]/cw[(width - 1):(width - hwidth)]
	x
}

rescale <- function(x, new, old = range(x)) {
	new[1] + (x - old[1])/(old[2] - old[1]) *
			(new[2] - new[1])
}

GSEAplot <- function(counts, snps, ...) {

	num <- length(counts)

	sel = rep.int(FALSE, num)

	sel[snps] <- TRUE

	countOrder <- order(counts, na.last = TRUE, decreasing = TRUE)
	counts <- counts[countOrder]
	sel <- sel[countOrder]

	snpLoc <- which(sel)

	col.bars <- "black"

	ylim <- c(-1, 1.5)

	plot(1:num, xlim = c(0, num), ylim = c(0, 2.1), type = "n",
			axes = FALSE, ylab = "", ...)

	lwd <- 50/length(snpLoc)
	lwd <- min(1.9, lwd)
	lwd <- max(0.2, lwd)

	barlim <- ylim[2] - c(1.5, 0.5)
	rect.yb <- 0
	rect.yt <- 0.5
	rect(0.5, 0, num + 0.5, 0.5, col = "pink", border = NA)

	if (length(snpLoc) > 0) {

		segments(snpLoc, barlim[1], snpLoc, barlim[2]/2, lwd = lwd, col = "black")
		segments(snpLoc, barlim[2]/2, snpLoc, barlim[2]/2 * 2, lwd = lwd, col = "black")

	}

	axis(side = 2, at = 0.5, padj = 3.8, cex.axis = 0.85,
			labels = "High # T>C reads", tick = FALSE)
	axis(side = 4, at = 0.5, padj = -3.8, cex.axis = 0.85,
			labels = "Low # T>C reads", tick = FALSE)
	prob <- (10:0)/10
	axis(at = seq(1, num, len = 11), side = 1, cex.axis = 0.7,
			las = 2, labels = format(quantile(counts, p = prob),
					digits = 1))

	ave.enrich1 <- length(snpLoc)/num
	worm1 <- tricubeMovingAverage(sel, span = 0.45)/ave.enrich1

	r.worm1 <- c(0, max(worm1))
	worm1.scale <- rescale(worm1, new = c(1.1 , 2.1 ), old = r.worm1)

	lines(x = 1:num, y = worm1.scale, col = "black", lwd = 2)
	abline(h = rescale(1, new = c(1.1 , 2.1), old = r.worm1), lty = 2)
	axis(side = 2, at = c(1.1 , 2.1 ), cex.axis = 0.8, labels = c(0, format(max(worm1), digits = 2)))
	axis(side = 2, labels = "Enrichment", at = 1.6 , padj = -0.6, tick = FALSE, cex.axis = 0.8)
}

pdf(opt$outputFile)

minCounts = round(opt$coverageCutoff * opt$variantFraction)

table = read.delim(opt$inputFile,header=FALSE,col.names = c("name","count","unmasked","masked","snp"))

table = table[table$unmasked >= minCounts,]

table = table[table$count >= quantile(table$count, 0.75),]

par(mfrow=c(2,1))

if (length(table(table$snp)) > 1) {

	blindTest = wilcox.test(table$unmasked ~ table$snp == "1", alternative = "less")
	maskedTest = wilcox.test(table$masked ~ table$snp == "1", alternative = "less")

	blindPvalue = blindTest$p.value

	if (blindPvalue < 0.01) {
		blindPvalue = "< 0.01"
	} else {
		blindPvalue =  paste("= ",round(blindPvalue,digits=2),sep="")
	}

	maskedPvalue = maskedTest$p.value

	if (maskedPvalue < 0.01) {
		maskedPvalue = "< 0.01"
	} else {
		maskedPvalue =  paste("= ",round(maskedPvalue,digits=2),sep="")
	}

	GSEAplot(table$unmasked, which(table$snp == 1), main="Blind", xlab = paste("Mann-Whitney-U:  p-value ",blindPvalue,sep=""))
	GSEAplot(table$masked, which(table$snp == 1), main="SNP-masked", xlab = paste("Mann-Whitney-U:  p-value ",maskedPvalue,sep=""))

} else {
	GSEAplot(table$unmasked, which(table$snp == 1), main="Blind", xlab = paste("Mann-Whitney-U:  p-value NA",sep=""))
	GSEAplot(table$masked, which(table$snp == 1), main="SNP-masked", xlab = paste("Mann-Whitney-U:  p-value NA",sep=""))
}

# wilcox.test(testTab$masked ~ testTab$snp == "1")
# wilcox.test(testTab$unmasked ~ testTab$snp == "1")
#
# ks.test(testTab$masked, testTab$unmasked)
# ks.test(testTab$unmasked[testTab$snp == "0"],testTab$unmasked[testTab$snp == "1"])

dev.off()

#!/usr/bin/env Rscript

# Script to compute half-lifes from SlamSeq data

# Copyright (c) 2015 Tobias Neumann, Philipp Rescheneder, Bhat Pooja
#
# This file is part of Slamdunk.
#
# Slamdunk is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# Slamdunk is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

library(getopt)

spec = matrix(c(
  'help'      , 'h', 0, "logical","print the usage of the command",
  'slamdunk', "f", 2,"character","Comma seperated list of SlamDunk results",
  'timepoints', "t", 2,"character","Comma seperated list of time points",
  'output', "o", 2,"character","Output tsv"
),ncol = 5,byrow=T)

opt = getopt(spec)

if ( !is.null(opt$help) || length(opt)==3 ) {
  #get the script name
  cmd = commandArgs(FALSE)
  self = strsplit(cmd[grep("--file",cmd)],"=")[[1]][2]
  cat(basename(self),": Create mismatch plots from rate tabs.\n\n")
  #print a friendly message and exit with a non-zero error code
  cat(getopt(spec,command = self,usage=T))
  q(status=1);
}

if ( is.null(opt$slamdunk) ) stop("arg slamdunk must be specified")
if ( is.null(opt$output) ) stop("arg output must be specified")
if ( is.null(opt$timepoints) ) stop("arg timepoints must be specified")

slamDunkFiles = opt$slamdunk
#slamDunkFiles = "/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_1_0min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_2_15min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_3_30min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_4_60min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_5_180min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_6_360min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_7_720min_reads_slamdunk_mapped_filtered_tcount.csv,/project/ngs/philipp/slamdunk-analysis/simulation/simulation_1/slamdunk/count/pooja_UTR_annotation_examples_8_1440min_reads_slamdunk_mapped_filtered_tcount.csv"
filesSlamDunk = as.character(ordered(strsplit(slamDunkFiles, ",")[[1]]))
outputFile = opt$output
timesParameter = opt$timepoints
times = as.numeric(strsplit(timesParameter, ",")[[1]])
times = times / 60


mergeRates <- function(times, files, perRead) {
  mergedRates = data.frame()
  for(i in 1:length(times)) {
    time = times[i]
    print(time)
    simDataFile = files[i]
    simulation = read.table(simDataFile)
    colnames(simulation) = c("chr", "start", "stop", "name", "strand", "conversionRate", "readsCPM", "tCount", "tcCount", "readCount", "convertedReads", "multiMapCount")
    if(nrow(mergedRates) == 0) {
      mergedRates = simulation[, c("chr", "start", "stop", "name", "strand")]
      mergedRates$avgReadsCPM = simulation$readsCPM
      mergedRates$avgMultimapper = simulation$multiMapCount
      if(perRead == TRUE) {
        mergedRates$conversionRate = simulation$convertedReads / simulation$readCount
      } else {
        mergedRates$conversionRate = simulation$conversionRate
      }
    } else {
      mergedRates$avgReadsCPM = mergedRates$avgReadsCPM + simulation$readsCPM
      mergedRates$avgMultimapper = mergedRates$avgMultimapper + simulation$multiMapCount
      if(perRead == TRUE) {
        mergedRates = cbind(mergedRates, simulation$convertedReads / simulation$readCount)
      } else {
        mergedRates = cbind(mergedRates, simulation$conversionRate)
      }
    }
  }
  colnames(mergedRates) = c("chr", "start", "stop", "name", "strand", "readsCPM", "multiMapCount", times)
  mergedRates$readsCPM = mergedRates$readsCPM / length(times)
  mergedRates$multiMapCount = mergedRates$multiMapCount / length(times)
  mergedRates
}

computeHalfLife <- function(rates, timepoints) {
  # Infere half life from data
  a_start<-max(rates) #param a is the y value when x=0
  k_start = log(2, base = exp(1))/5

  halfLifePred = NA
  C = NA
  k = NA

  tryCatch( {
    fit = nls(rates ~ a*(1-exp(-k*(timepoints))), start=list(a=a_start,k=k_start))
    halfLifePred = log(2, base = exp(1))/coef(fit)[2] * 60
    C = coef(fit)[1]
    k = coef(fit)[2]
  }, error=function(e){})
  summary(fit)

  RSS.p <- sum(residuals(fit)^2)
  TSS <- sum((rates - mean(rates))^2)
  rsquared = 1 - (RSS.p/TSS)

  c(halfLifePred, C, k, rsquared)
}

perRead = F
slamDunkMergedRates = mergeRates(times, filesSlamDunk, perRead)

halfLifeTable = data.frame()

for(utr in 1:nrow(slamDunkMergedRates)) {
  #utr = 8
  slamDunkMergedRates[utr,]
  pulseSlamDunk = data.frame(y = as.numeric(t(slamDunkMergedRates[utr, 8:(7 + length(times))])[,1]), x = times)

  result = computeHalfLife(pulseSlamDunk$y, pulseSlamDunk$x)
  #rates = pulseSlamDunk$y
  #timepoints = pulseSlamDunk$x
  halfLifeTable = rbind(halfLifeTable, cbind(slamDunkMergedRates[utr, c("chr", "start", "stop", "name", "strand", "readsCPM", "multiMapCount")], result[1]))
}

colnames(halfLifeTable) = c("#chr", "start", "stop", "name", "strand", "readsCPM", "multiMapCount", "score")

write.table(halfLifeTable, outputFile, sep = "\t", quote = F, row.names = F, col.names = T)

#!/usr/bin/env Rscript

# Script to plot pairwise correlations and PCA
#
# Copyright (c) 2015 Tobias Neumann, Philipp Rescheneder.
#
# This file is part of Slamdunk.
#
# Slamdunk is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# Slamdunk is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Helper

my_panel_cor <- function(x, y, digits=2, prefix="", cex.cor, ...)
{
	usr <- par("usr"); on.exit(par(usr))
	par(usr = c(0, 1, 0, 1))


	toUse = which(is.finite(x) & is.finite(y) & (x|y>0))
	r <- abs(cor(x[toUse], y[toUse]))


	txt <- format(c(r, 0.123456789), digits=digits)[1]
	txt <- paste(prefix, txt, sep="")
	if(missing(cex.cor)) cex.cor <- 0.8/strwidth(txt)
	text(0.5, 0.5, txt, cex = cex.cor * r)
}

my_panel_smooth <- function(x, y,lcol="red")

{
	smoothScatter(x,y,add=T)
	abline(0,1,col=lcol)
}

library(getopt)

spec = matrix(c(
				'help'      , 'h', 0, "logical","print the usage of the command",
				'sampleTab', "i", 2,"character","csv table of sample counts",
				'outputPrefix', "o", 2,"character","output file name prefix"
		),ncol = 5,byrow=T)

opt = getopt(spec)

if ( !is.null(opt$help) || length(opt)==1 ) {
	#get the script name
	cmd = commandArgs(FALSE)
	self = strsplit(cmd[grep("--file",cmd)],"=")[[1]][2]
	cat(basename(self),": Compute sample comparison statistics from sample counts.\n\n")
	#print a friendly message and exit with a non-zero error code
	cat(getopt(spec,command = self,usage=T))
	q(status=1);
}


if ( is.null(opt$sampleTab) ) stop("arg sampleTab must be specified")
if ( is.null(opt$outputPrefix) ) { opt$outputPrefix = "sampleCorrelation" }

rates = read.table(opt$sampleTab,header=TRUE,sep=";", comment.char = "")

if (ncol(rates) < 6) {
	print("No need for calculating pairwise statistics for single sample")
	quit(status=0)
}

library(RColorBrewer, lib.loc = libLoc)
library(lattice, lib.loc = libLoc)
library(matrixStats, lib.loc = libLoc)

values = data.matrix(rates[,c(5:ncol(rates))])

##################################################
# PCA
##################################################

rowVariances = rowVars(data.matrix(values))

select = order(rowVariances, decreasing = TRUE)[seq_len(min(500, length(rowVariances)))]

pca = prcomp(t(values[select, ]))

if (ncol(values) == 2) {
	col = brewer.pal(3, "Paired")[1:2]
} else if (ncol(values) > 12) {
	getPalette = colorRampPalette(brewer.pal(9, "Set1"))
	col = getPalette(ncol(values))
} else {
	col = brewer.pal(ncol(values), "Paired")
}

# Get amount of explained variance (see summary(pca))
varianceProportion = pca$sdev ^ 2 / sum(pca$sdev ^ 2)

pdf(paste(opt$outputPrefix,"_PCA.pdf",sep=""))

if (ncol(values) > 12) {

	xyplot(PC2 ~ PC1, groups = colnames(values), data = as.data.frame(pca$x),
		pch = 20, cex = 2, aspect = "iso", col = col, xlab = paste("PC1 (", round(varianceProportion[1],digits=2), " variance)",sep=""),
		ylab = paste("PC2 (", round(varianceProportion[2],digits=2), " variance)",sep=""),
	)

} else {

	xyplot(PC2 ~ PC1, groups = colnames(values), data = as.data.frame(pca$x),
			pch = 20, cex = 2, aspect = "iso", col = col, main = draw.key(key = list(rect = list(col = col),
							text = list(colnames(values)), rep = FALSE)), xlab = paste("PC1 (", round(varianceProportion[1],digits=2), " variance)",sep=""),
			ylab = paste("PC2 (", round(varianceProportion[2],digits=2), " variance)",sep=""),
	)

}

dev.off()

##################################################
# Pairwise correlations
##################################################

if (ncol(values) <= 12) {

	pdf(paste(opt$outputPrefix,"_pairwiseCorrelation.pdf",sep=""))

	pairs(values,upper.panel=my_panel_smooth,lower.panel=my_panel_cor)

	dev.off()
}

#signal success and exit.
q(status=0)

#!/usr/bin/env Rscript

# Script to plot TC context rates of reads

# Copyright (c) 2015 Tobias Neumann, Philipp Rescheneder.
#
# This file is part of Slamdunk.
#
# Slamdunk is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# Slamdunk is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

library(getopt)

spec = matrix(c(
  'help'      , 'h', 0, "logical","print the usage of the command",
  'rateTab', "f", 2,"character","tsv table of rate files",
  'outputFile', "O", 2,"character","output pdf file name"
),ncol = 5,byrow=T)

opt = getopt(spec)

if ( !is.null(opt$help) || length(opt)==1 ) {
  #get the script name
  cmd = commandArgs(FALSE)
  self = strsplit(cmd[grep("--file",cmd)],"=")[[1]][2]
  cat(basename(self),": Create mismatch plots from rate tabs.\n\n")
  #print a friendly message and exit with a non-zero error code
  cat(getopt(spec,command = self,usage=T))
  q(status=1)
}


if ( is.null(opt$rateTab) ) stop("arg rateTab must be specified")
if ( is.null(opt$outputFile) ) { opt$outputFile = "out.pdf" }

library(ggplot2)
library(gridExtra)

rates = read.table(opt$rateTab,stringsAsFactors=FALSE,col.names = c("sample","file"),comment.char = "")

pdf(opt$outputFile)
plotList = list()

for (i in 1:nrow(rates)) {
  curTab = read.table(rates$file[i],stringsAsFactors=FALSE,header=TRUE)

  subFront = curTab[1:2,]
  subBack = curTab[4:5,]
  names(subBack) = curTab[3,]

  #subFront = read.table(rates$file[i],stringsAsFactors=FALSE,header=TRUE, nrow=1)
  #subBack = read.table(rates$file[i],stringsAsFactors=FALSE,header=TRUE, nrow=1,skip=2)

  printTabFront = data.frame(contexts=rep(names(subFront),each=2),strand = factor(rep(c("+","-"),ncol(subFront)),levels=c("+","-")),
                             rate_percent = as.numeric(unlist(subFront)))
  printTabBack = data.frame(contexts=rep(names(subBack),each=2),strand = factor(rep(c("+","-"),ncol(subBack)),levels=c("+","-")),
                            rate_percent = as.numeric(unlist(subBack)))

  printTabFront$rate_percent = printTabFront$rate_percent / sum(printTabFront$rate_percent)
  printTabBack$rate_percent = printTabBack$rate_percent / sum(printTabBack$rate_percent)

  # Ignore N contexts for now
  printTabFront = printTabFront[-grep("NT",printTabFront$contexts),]
  printTabBack = printTabBack[-grep("TN",printTabBack$contexts),]

  curPlot = qplot(x=contexts, y=rate_percent, fill=strand,data=printTabFront) + geom_bar(stat="identity") + geom_text(aes(label = round(rate_percent,digits=2)), size = 3, hjust = 0.5, vjust = 1.5, position = "stack") + ylab("TC context percent %") + xlab(rates$sample[i]) +
    theme(text = element_text(size=6),axis.text.x = element_text(size=6), plot.title = element_text(size=10))
  plotList[[length(plotList)+1]] <- curPlot + ylim(0.0,1.0) + ggtitle("5' T->C context")
  curPlot = qplot(x=contexts, y=rate_percent, fill=strand,data=printTabBack) + geom_bar(stat="identity") + geom_text(aes(label = round(rate_percent,digits=2)), size = 3, hjust = 0.5, vjust = 1.5, position = "stack") + ylab("TC context percent %") + xlab(rates$sample[i]) +
    theme(text = element_text(size=6),axis.text.x = element_text(size=6),plot.title = element_text(size=10))
  plotList[[length(plotList)+1]] <- curPlot + ylim(0.0,1.0) + ggtitle("3' T->C context")
}

do.call(grid.arrange,  plotList)

dev.off()

#signal success and exit.
q(status=0)

#!/usr/bin/env Rscript

# Copyright (c) 2015 Tobias Neumann, Philipp Rescheneder.
#
# This file is part of Slamdunk.
#
# Slamdunk is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# Slamdunk is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

library(getopt)

spec = matrix(c(
				'help'      , 'h', 0, "logical","print the usage of the command",
				'utr' 		, 'u', 0, "logical","utr plotting",
				'inputFile', "i", 2,"character","tsv table of mutations per position",
				'outputFile', "o", 2,"character","output pdf file name"
		),ncol = 5,byrow=T)

opt = getopt(spec)

if ( !is.null(opt$help) || length(opt)==1 ) {
	#get the script name
	cmd = commandArgs(FALSE)
	self = strsplit(cmd[grep("--file",cmd)],"=")[[1]][2]
	cat(basename(self),": Create mismatches per read/UTR position plots.\n\n")
	#print a friendly message and exit with a non-zero error code
	cat(getopt(spec,command = self,usage=T))
	q(status=1);
}

positionLabel = "Position on read"
mutationLabel = "% of reads with mutation"

if( !is.null(opt$utr)) {
	positionLabel = "Position at 3' UTR end (200 bp upstream)"
	mutationLabel = "% of UTRs with mutation"
}

if ( is.null(opt$inputFile) ) stop("arg input must be specified")
if ( is.null(opt$outputFile) ) { opt$outputFile = paste(opt$inputFile, ".pdf", sep="") }


mut = read.table(opt$inputFile, comment.char = "#")

if (is.null(mut$V6)) {
	mut$V6 = mut$V5
}

#mut = read.table("test_mut_bowtie.csv")

#totalFwd = mut[1,1]
#totalRev = mut[1,2]
#tcFwd = mut[1,3]
#tcRev = mut[1,4]

#mut = mut[-1,]

counts = rbind(c(mut$V1)/c(mut$V5) * 100, c(mut$V2)/c(mut$V6) * 100)
countsTC = rbind(c(mut$V3)/c(mut$V5) * 100, c(mut$V4)/c(mut$V6) * 100)

##################################################################
# Workaround for 0 counts (need to work out what's going on there

counts[is.nan(counts)] = 0
countsTC[is.nan(countsTC)] = 0

##################################################################
pdf(opt$outputFile, width=10, height=10)
par(mfrow=c(2,1))

# Scale to next 10
barplot(counts, beside=T, names.arg=1:nrow(mut), main="All mutations", ylim=c(0,max(10,ceiling(counts / 10) * 10)), xlab=positionLabel, ylab=mutationLabel, legend=c("forward", "reverse"))
#barplot(counts, beside=T, names.arg=1:nrow(mut), main="All mutations", ylim=c(0,10), xlab=positionLabel, ylab=mutationLabel, legend=c("forward", "reverse"))
# Scale to next 1
barplot(countsTC, beside=T, names.arg=1:nrow(mut), main="T->C on fwd, A->G on rev", ylim=c(0,max(1,ceiling(countsTC))), xlab=positionLabel, ylab=mutationLabel, legend=c("forward", "reverse"))
#barplot(countsTC, beside=T, names.arg=1:nrow(mut), main="T->C on fwd, A->G on rev", ylim=c(0,1), xlab=positionLabel, ylab=mutationLabel, legend=c("forward", "reverse"))

dev.off()
